VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3840
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   24
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   297
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   256
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chAA 
      Caption         =   "AntiAliasing"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1020
      TabIndex        =   1
      Top             =   4020
      Value           =   1  'Checked
      Width           =   1935
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   300
      Top             =   2760
   End
   Begin VB.PictureBox pic 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   1575
      Left            =   60
      ScaleHeight     =   101
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   73
      TabIndex        =   0
      Top             =   60
      Visible         =   0   'False
      Width           =   1155
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Double
  biClrUsed As Double
End Type

Private Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As Long
End Type

Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Dim bi32BitInfo As BITMAPINFO
Dim ArIn() As Long, ArOut() As Long
Dim ix As Long, iy As Long
Dim Running As Boolean, FPS As Long

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  If KeyCode = 27 Then Running = False
End Sub

Private Sub Form_Load()
Static t As Single
  Move Left, Top, Width - Screen.TwipsPerPixelX * (Me.ScaleWidth - 256), Me.Height - Screen.TwipsPerPixelY * (Me.ScaleHeight - 256 - 32)
  chAA.Move 64, 260
  Show
  ReadPic
  PrepareOut
  Running = True
  Do While Running
    If chAA Then
      RGBRotateAA ArIn(), ArOut(), 89.5, 67, 128, 128, t, &H334455
    Else
      RGBRotate ArIn(), ArOut(), 89.5, 67, 128, 128, t, &H334455
    End If
    SetDIBitsToDevice Me.hDC, 0, 0, ix, iy, 0, 0, 0, iy, ArOut(0, 0), bi32BitInfo, 0
    FPS = FPS + 1
    t = t + 0.003: If t > 6.283186 Then t = t - 6.283186
    DoEvents
  Loop
  Unload Me
End Sub

Private Sub PrepareOut()
  ix = 256
  iy = 256
  With bi32BitInfo.bmiHeader
    .biBitCount = 32
    .biPlanes = 1
    .biSize = Len(bi32BitInfo.bmiHeader)
    .biWidth = ix
    .biHeight = iy
    .biSizeImage = 4 * ix * iy
  End With
  ReDim ArOut(ix - 1, iy - 1)
End Sub

Private Sub ReadPic()
  pic.Picture = LoadPicture("test.jpg")
  ReDim ArIn(pic.ScaleWidth - 1, pic.ScaleHeight - 1)
  With bi32BitInfo.bmiHeader
    .biBitCount = 32
    .biPlanes = 1
    .biSize = Len(bi32BitInfo.bmiHeader)
    .biWidth = pic.ScaleWidth
    .biHeight = pic.ScaleHeight
    .biSizeImage = 4 * pic.ScaleWidth * pic.ScaleHeight
  End With
  GetDIBits pic.hDC, pic.Image.Handle, 0, pic.ScaleHeight, ArIn(0, 0), bi32BitInfo, 0
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  If Running Then
    Running = False
    Cancel = 1
  End If
End Sub

Private Sub Timer1_Timer()
  Caption = Str(FPS) & " fps"
  FPS = 0
End Sub
