Attribute VB_Name = "modRotate"
' 
'   (Mikle).
'www.vbstreets.ru

Option Explicit

Private Type Col
  r As Long
  g As Long
  b As Long
End Type

'     
'    
'   ,    0,  Long
'sx, sy -    
'dx, dy -    
'a -    
'BackCol -  

Public Sub RGBRotateAA(ArIn() As Long, ArOut() As Long, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal a As Single, ByVal BackCol As Long)
  Dim sw As Long, sh As Long, dw As Long, dh As Long
  Dim x As Long, y As Long
  Dim xx As Long, yy As Long
  Dim ix As Long, iy As Long
  Dim tx As Long, ty As Long
  Dim ssx As Long, ssy As Long
  Dim SinA As Long, CosA As Long
  Dim c As Col, bc As Col
  sw = UBound(ArIn(), 1) + 1
  sh = UBound(ArIn(), 2) + 1
  dw = UBound(ArOut(), 1) + 1
  dh = UBound(ArOut(), 2) + 1
  ssx = sx * &H10000
  ssy = sy * &H10000
  SinA = Sin(a) * &H10000
  CosA = Cos(a) * &H10000
  bc = RGBToCol(BackCol)
  For y = 0 To dh - 1
    xx = ssx - dx * CosA + (y - dy) * SinA
    yy = ssy + (y - dy) * CosA + dx * SinA
    For x = 0 To dw - 1
      xx = xx + CosA
      yy = yy - SinA
      ix = xx \ &H10000: iy = yy \ &H10000
      tx = xx And &HFFFF&: ty = yy And &HFFFF&
      If ix < -1 Or ix >= sw Or iy < -1 Or iy >= sh Then
        ArOut(x, y) = BackCol
      ElseIf ix >= 0 And ix < sw - 1 And iy >= 0 And iy < sh - 1 Then
        c = ColMulVal(RGBToCol(ArIn(ix, iy)), (&H10000 - tx), (&H10000 - ty))
        ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy)), tx, (&H10000 - ty))
        ColAddCol c, ColMulVal(RGBToCol(ArIn(ix, iy + 1)), (&H10000 - tx), ty)
        ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy + 1)), tx, ty)
        ArOut(x, y) = ColToRGB(c)
      Else
        If ix = -1 Or iy = -1 Then c = ColMulVal(bc, (&H10000 - tx), (&H10000 - ty)) Else c = ColMulVal(RGBToCol(ArIn(ix, iy)), (&H10000 - tx), (&H10000 - ty))
        If ix = sw - 1 Or iy = -1 Then ColAddCol c, ColMulVal(bc, tx, (&H10000 - ty)) Else ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy)), tx, (&H10000 - ty))
        If ix = -1 Or iy = sh - 1 Then ColAddCol c, ColMulVal(bc, (&H10000 - tx), ty) Else ColAddCol c, ColMulVal(RGBToCol(ArIn(ix, iy + 1)), (&H10000 - tx), ty)
        If ix = sw - 1 Or iy = sh - 1 Then ColAddCol c, ColMulVal(bc, tx, ty) Else ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy + 1)), tx, ty)
        ArOut(x, y) = ColToRGB(c)
      End If
    Next x
  Next y
End Sub

'   

Public Sub RGBRotate(ArIn() As Long, ArOut() As Long, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal a As Single, ByVal BackCol As Long)
  Dim sw As Long, sh As Long, dw As Long, dh As Long
  Dim x As Long, y As Long
  Dim xx As Long, yy As Long
  Dim ix As Long, iy As Long
  Dim ssx As Long, ssy As Long
  Dim SinA As Long, CosA As Long
  sw = UBound(ArIn(), 1) + 1
  sh = UBound(ArIn(), 2) + 1
  dw = UBound(ArOut(), 1) + 1
  dh = UBound(ArOut(), 2) + 1
  ssx = sx * &H10000
  ssy = sy * &H10000
  SinA = Sin(a) * &H10000
  CosA = Cos(a) * &H10000
  For y = 0 To dh - 1
    xx = ssx - dx * CosA + (y - dy) * SinA
    yy = ssy + (y - dy) * CosA + dx * SinA
    For x = 0 To dw - 1
      xx = xx + CosA
      yy = yy - SinA
      ix = xx \ &H10000: iy = yy \ &H10000
      If ix < 0 Or ix >= sw Or iy < 0 Or iy >= sh Then
        ArOut(x, y) = BackCol
      Else
        ArOut(x, y) = ArIn(ix, iy)
      End If
    Next x
  Next y
End Sub

' 
Private Sub ColAddCol(Dest As Col, Src As Col)
  Dest.r = Dest.r + Src.r
  Dest.g = Dest.g + Src.g
  Dest.b = Dest.b + Src.b
End Sub

Private Function ColMulVal(Src As Col, ByVal v1 As Long, ByVal v2 As Long) As Col
  ColMulVal.r = (Src.r * v1 \ &H10000) * v2 \ &H10000
  ColMulVal.g = (Src.g * v1 \ &H10000) * v2 \ &H10000
  ColMulVal.b = (Src.b * v1 \ &H10000) * v2 \ &H10000
End Function

Private Function ColToRGB(c As Col) As Long
  ColToRGB = c.r * &H10000 + c.g * &H100 + c.b
End Function

Private Function RGBToCol(ByVal c As Long) As Col
  RGBToCol.r = (c And &HFF0000) \ &H10000
  RGBToCol.g = (c And &HFF00&) \ &H100
  RGBToCol.b = c And &HFF
End Function
